#include "colors.inc"
#include "shapes.inc"

camera {
  location <0,9,40>
  //location <8,2,23>
  look_at <0,6,0>
  //look_at <8,2,21>
 }

plane {y, 0 pigment{color red .7 green .3 blue .1}}
plane {x, 0 pigment { color rgb <0.13, 0.41, 0.37> * 0.35 } finish {ambient 0.1 diffuse 0.5 reflection 1} rotate y*45}
plane {z, 0 pigment { color rgb <0.13, 0.41, 0.37> * 0.35 } finish {ambient 0.1 diffuse 0.5 reflection 1} rotate y*45}
#local cnt = 0;
#while(cnt < 20)
        #local cnt = cnt + 1;          
        #local cnt2 = 0; 
        #local col = 0;
        #while(cnt2 < cnt)                            
                #local cnt2 = cnt2 + 1;
                #local rad1 = radians((360/cnt)*cnt2);
                #local locx = cos(rad1)*(cnt/4) + sin(rad1)*(cnt/4);
                #local locz = sin(rad1)*(cnt/4) - cos(rad1)*(cnt/4); 
                #local col = col + 1;
                #if(col=5)
                        #local col = 0;
                #end
                sphere {<0,0,0> ,1 pigment {    
                        #if(col = 0)
                                color rgb<0,0,1>
                        #end
                        #if(col = 1)
                                color rgb<.3,.3,.3> 
                        #end
                        #if(col = 2)
                                color rgb<0,1,0> 
                        #end        
                        #if(col = 3)
                                color rgb<1,0,0>
                        #end
                        #if(col = 4)
                                color rgb<1,1,0>                        
                        #end                                
                        } finish {ambient 0.1 diffuse 0.5 
                        reflection 
                        #if(col = 0)
                                color rgb<0,0,1>
                        #end
                        #if(col = 1)
                                color rgb<1,1,1> 
                        #end
                        #if(col = 2)
                                color rgb<0,1,0> 
                        #end        
                        #if(col = 3)
                                color rgb<1,0,0>
                        #end
                        #if(col = 4)
                                color rgb<1,1,0>                        
                        #end                                                        
                        } #translate<0,0,0> #translate<locx,24-cnt,locz>}
        #end

#end  
//box 1
box{<0,0,0>,<2,2,3> pigment{color rgb<0,1,0>} translate<6,0,9>}
box{<0,0,0>,<3,3,3> pigment{color rgb<1,0,0>} translate<3,0,6>}
box{<0,0,0>,<2,1,4> pigment{color rgb<1,1,0>} translate<4,0,9>}
box{<0,0,0>,<4,2,3> pigment{color rgb<1,0,1>} translate<0,0,9>}
box{<0,0,0>,<4,2.5,3> pigment{color rgb<0,0,1>} translate<-1,0,6>}
box{<0,0,0>,<1,1,1> pigment{color rgb<1,1,1>} translate<-1.5,0,13>}
box{<0,0,0>,<4,2,3> pigment{color rgb<1,1,0>} translate<-6,0,9>}
box{<0,0,0>,<2,2,2> pigment{color rgb<0,1,0>} translate<-8,0,9>}
box{<0,0,0>,<4,3,3> pigment{color rgb<0,1,1>} translate<-5,0,6>}
box{<0,0,0>,<2,2,2> pigment{color rgb<1,0,0>} translate<-7,0,6>}     
disc{
        <0,.2,0>, y, 19,18.8  
    }
disc{
        <0,.2,0>, y, 21.2,21  
    }  
#local cnt = 0;
#while(cnt < 360)    
        #local rad1 = radians(cnt);
        #local locx = cos(rad1)*14.2 + sin(rad1)*14.2;
        #local locz = sin(rad1)*14.2 - cos(rad1)*14.2; 
        box{<-.1,0,-1.5>,<.1,.2,1.5> rotate<0,cnt + 45,0> translate<0,0,0> translate<locx,0,-locz>}
        #local cnt = cnt + 10;
#end
//begin train
union{ 
        box{<-2,2.3,-1>,<-.7,2.4,1> pigment{color rgb<1,0,0>}}  
        box{<-2,0,-1>,<-.7,2.3,1> pigment{color rgb<0,1,0>}}  
        cylinder {
                <2,1,0>, <-1,1,0>,  1
                pigment{color rgb<0,1,0>}
        }
        cone {
                <2,1,0>, 1    // Center and radius of one end
                <2.5,1,0>, 0    // Center and radius of other end
                pigment{color rgb<0,1,0>}
        }
        cylinder {
                <0,2,0>, <0,2.5,0>,  .2
                pigment{color rgb<1,0,0>} 
                translate<1.5,0,0>
        }                          
        box {
                <2,0,1>,<-1,1,-1>       
                pigment{color rgb<0,1,0>}
        }  

        triangle {
                < 0,  .7,  0>,  // <Vertex1>
                < 1,  0,  0>,  // <Vertex2>
                < 0,  0, -1>   // <Vertex3>
                pigment{color rgb<0,1,0>}
                translate<2,0,0>
        } 
        triangle {
                < 0,  .7,  0>,  // <Vertex1>
                < 1,  0,  0>,  // <Vertex2>
                < 0,  0,  1>   // <Vertex3> 
                pigment{color rgb<0,1,0>}
                translate<2,0,0>
        }
        disc{<-1.1,.5,1.1>, z, .7,0 pigment{color rgb<0,0,1>}}                          
        disc{<-1.1,.5,-1.1>, z, .7,0 pigment{color rgb<0,0,1>}}
        cylinder {<-1.1,.5,1.11>, <-1.1,.5,-1.11>, .15}
        disc{<1.6,.1,1.1>, z, .3,0 pigment{color rgb<0,0,1>}}
        disc{<1.6,.1,-1.1>, z, .3,0 pigment{color rgb<0,0,1>}}
        cylinder {<1.6,.1,1.11>, <1.6,.1,-1.11>, .1}
        translate<0,.4,-19.9>
        rotate y*161
} 
//end train

//first car
union{  
        box{<-2,0,-1>,<2,1.2,1> pigment{color rgb<0,0,1>}}
        disc{<-1.5,.1,1.1>, z, .3,0 pigment{color rgb<0,0,0>}}                          
        disc{<-1.5,.1,-1.1>, z, .3,0 pigment{color rgb<0,0,0>}}
        cylinder {<-1.5,.1,1.11>, <-1.5,.1,-1.11>, .1 pigment{color rgb<1,0,0>}}
        disc{<1.5,.1,1.1>, z, .3,0 pigment{color rgb<0,0,0>}}                          
        disc{<1.5,.1,-1.1>, z, .3,0 pigment{color rgb<0,0,0>}}
        cylinder {<1.5,.1,1.11>, <1.5,.1,-1.11>, .1 pigment{color rgb<1,0,0>}}
        translate<0,.4,-19.9>
        rotate y*174
}
//end car

//second car
union{
        box{<-2,0,-1>,<2,1.2,1> pigment{color rgb<0,0,1>}}
        disc{<-1.5,.1,1.1>, z, .3,0 pigment{color rgb<0,0,0>}}                          
        disc{<-1.5,.1,-1.1>, z, .3,0 pigment{color rgb<0,0,0>}}
        cylinder {<-1.5,.1,1.11>, <-1.5,.1,-1.11>, .1 pigment{color rgb<1,0,0>}}
        disc{<1.5,.1,1.1>, z, .3,0 pigment{color rgb<0,0,0>}}                          
        disc{<1.5,.1,-1.1>, z, .3,0 pigment{color rgb<0,0,0>}}
        cylinder {<1.5,.1,1.11>, <1.5,.1,-1.11>, .1 pigment{color rgb<1,0,0>}}
        translate<0,.4,-19.9>
        rotate y*187
}
//end car

//caboose    
union{
        box{<-2,0,-1>,<2,1.3,1> pigment{color rgb<1,0,0>}}
        box{<-2,1.3,-1>,<2,1.4,1>}
        box{<-.7,1,-1.01>,<.7,1.8,1.01>}
        disc{<-1.5,.1,1.1>, z, .3,0 pigment{color rgb<0,0,0>}}                          
        disc{<-1.5,.1,-1.1>, z, .3,0 pigment{color rgb<0,0,0>}}
        cylinder {<-1.5,.1,1.11>, <-1.5,.1,-1.11>, .1 pigment{color rgb<1,0,0>}}
        disc{<1.5,.1,1.1>, z, .3,0 pigment{color rgb<0,0,0>}}                          
        disc{<1.5,.1,-1.1>, z, .3,0 pigment{color rgb<0,0,0>}}
        cylinder {<1.5,.1,1.11>, <1.5,.1,-1.11>, .1 pigment{color rgb<1,0,0>}}
        translate<0,.4,-19.9>
        rotate y*200
}
//end caboose

light_source {<0,24,1>, rgb <1,1,.8>   jitter
        photons{    
                reflection on
                refraction on  
        }
        looks_like {polygon
        {
                10,
                #local cnt = 0;
                #while(cnt<10)      
                        #local orad = radians(cnt*36);
                        #local ox = cos(orad)*.5 + sin(orad)*.5;
                        #local oy = sin(orad)*.5 - cos(orad)*.5;  
                        #local irad = radians((cnt+1)*36);
                        #local ix = cos(irad)*.25 + sin(irad)*.25;
                        #local iy = sin(irad)*.25 - cos(irad)*.25;
                        #local cnt = cnt + 2;
                        <ox,oy,0> <ix,iy,0>
                #end
                pigment{color rgb<1,1,1>}} finish{ambient .9 diffuse .9}
        }
} 
//signature
union
{
        text {
          ttf
          "crystal.ttf",
          "Copyright 2004"
          0.1,
          0
        }    
        
        // create a curved tube object translating a sphere along a certain path
        sphere_sweep {
          linear_spline                 // linear curve
          //cubic_spline                // alternative spline curves
          //b_spline
          22,                            // number of specified sphere positions
          <-1, 1, 0>, .1                // position, radius
          <0, 1, 0>, .1                 // ...
          <-1, -1, 0>, .1
          <-.5,  0, 0>, .1
          <-1, 0, 0>, .1
          <-.5,  0, 0>, .1
          <0,  1, 0>, .1
          <0, -1, 0>, .1
          <1, 1, 0>, .1
          <1, -1, 0>, .1
          <1.6, -1, 0>, .1
          <1.91,-.95, 0>, .1
          <2.19,-.81, 0>, .1
          <2.41,-.59, 0>, .1
          <2.55,-.31, 0>, .1
          <2.6,0, 0>, .1
          <2.55,.31, 0>, .1
          <2.41,.59, 0>, .1
          <2.19,.81, 0>, .1
          <1.91,.95, 0>, .1
          <1.6, 1, 0>, .1
          <1, 1, 0>, .1
          //tolerance 0.001             // optional  
          translate <16,.6,0>
          scale .5
        }
       Axis_Rotate_Trans(y,180)
       translate <0b,1,25>
       pigment {rgb <0,1,0>}
       //scale 0.8         
}
//end signature

                       
light_source {
    <0, 30, 50>
    color rgb<1,.3,.3>
    spotlight
    radius 40
    //falloff 20
    tightness 10
    point_at <0, 0, 0>
  }
global_settings {
   photons {
     count 20000
     autostop 0
     jitter .4
   }      
   //ambient_light color rgb<1,1,1>
 }

light_source {
    <0, 5, 1>
    color rgb<1,.3,.3>
  }


